/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_image.js,v 1.2 2006/04/11 14:27:34 froebel Exp $
 * ***** END CVS HEADERS ***** */

var stringBundle = null;

function onLoad() {
	stringBundle = document.getElementById("wikipediastrings");
	var params = window.arguments[1];
	document.getElementById('image-file').value = params[0];
	document.getElementById('image-description').value = params[1];
	if (params[0] != "") {
		document.getElementById('image-description').focus();
	}
}

function onAccept() {
	var ok = window.arguments[0];
	var params = window.arguments[1];
	params[0] = document.getElementById('image-file').value;
	params[1] = document.getElementById('image-description').value;
	params[2] = document.getElementById('format-thumb').selected;
	params[3] = document.getElementById('format-thumbsized').selected;
	params[4] = document.getElementById('format-framed').selected;
	params[5] = document.getElementById('format-full').selected;
	params[6] = document.getElementById('format-pixels').value;
	params[7] = document.getElementById('image-alignment').selectedIndex;
	ok[0] = true;
	return true;
}

function onCancel() {
  var ok = window.arguments[0]; 
  ok[0] = false;
  return true;
}

function browseImages() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.appendFilters(nsIFilePicker.filterImages | nsIFilePicker.filterAll);
	fp.filterIndex = 1;
	fp.init(window, stringBundle.getString("wikipedia.image.selectfiledialogtitle"), nsIFilePicker.modeOpen);
	var res = fp.show();
	if (res == nsIFilePicker.returnOK) {
		var file = fp.file;
		document.getElementById('image-file').value = file.leafName;
	}
}