/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distribselectGameuted on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Wikipedia Toolbar.
 *
 * The Initial Developer of the Original Code is
 * Bananeweizen
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Shane A. Froebel <shane.froebel@gmail.com/bugs@bugssite.org>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 /* ***** CVS HEADERS *****
 * $Id: wikipedia_preferences_wikis.js,v 1.12 2006/05/16 17:53:44 froebel Exp $
 * ***** END CVS HEADERS ***** */

var wbPrefs = null;

var count;
var lcount;

function onLoadPageWikis() {
	count = wbPrefs.getIntPref(OPTION_USER_WIKI+".count");
	if (count == 0) {
		document.getElementById('templates-tree-siteadmin').disabled = true;
	}
	loadUserWikis();
	loadUserWikisLang();
}

/************ LOAD AREA & GLOBAL AREA *************/

function loadUserWikis() {
	wbPrefs = getPreferences();
	//	full template packages
	var count = wbPrefs.getIntPref(OPTION_USER_WIKI+".count");
	for (var i = 0; i < count; i++) {
		var label = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_WIKI+"."+i+".label"));
		var installurl = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_WIKI+"."+i+".installurl"));
		addUserWikiHeader(label, installurl, "install");
	}
	
	//	basic sites
	var count = wbPrefs.getIntPref(OPTION_USER_WIKI_NOINSTALL+".count");
	for (var i = 0; i < count; i++) {
		var label = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_WIKI_NOINSTALL+"."+i+".label"));
		var installcode = decodeURIComponent(wbPrefs.getCharPref(OPTION_USER_WIKI_NOINSTALL+"."+i+".installcode"));
		addUserWikiHeader(label, installcode, "basic");
	}	
}

function loadUserWikisLang() {
	//	full template packages
	var count = wbPrefs.getIntPref(OPTION_USER_WIKI+".count");
	for (var i = 0; i < count; i++) {
		var installurl = wbPrefs.getCharPref(OPTION_USER_WIKI+"."+i+".installurl");
		var fullfile = "chrome://"+installurl+"/content/"+installurl+ "_templates.xml";
		//	get the type overall settings of the xml file		
		var nodelistsite = getNodes(fullfile,"/site/overall");
		nodesite = nodelistsite[i];
		
		var name = document.evaluate("name/text()",nodesite,null,0,null);
		var type = document.evaluate("type/text()",nodesite,null,0,null);
		var icon = document.evaluate("icon/text()",nodesite,null,0,null);
		var thelang = document.evaluate("lang/text()",nodesite,null,0,null);	
		
		name = name.iterateNext().nodeValue;
		type = type.iterateNext().nodeValue;
		icon = icon.iterateNext().nodeValue;
		
		var thelang = thelang.iterateNext().nodeValue;
		var lang = thelang.split(",");
		
		//	add to the view site template drop down list - this is on another tab
		populateSiteList(installurl, icon, name);
		
		for (var l = 0; l < lang.length; l++) {
			var nodelistlang = getNodes(fullfile,"/site/"+lang[l]+"/settings");
			nodelang = nodelistlang[0];
			var fullname = document.evaluate("fullname/text()",nodelang,null,0,null);
			var loc = document.evaluate("loc/text()",nodelang,null,0,null);
			fullname = fullname.iterateNext().nodeValue;
			loc = loc.iterateNext().nodeValue;
			langcode = lang[l];
			addUserWikiItem(installurl,fullname,langcode,loc,type,"install");
		}
	}
	//	templates alone
}

function populateSiteList(id, icon, sitename) {
	if (document.getElementById("template-site-list-group").hidden) {
		document.getElementById("template-site-list-group").hidden = false;
	}
	var list = document.getElementById("template-site-list");
	var popup = document.getElementById("template-site-items");
	var item;

	while (popup.hasChildNodes())
	{
		popup.removeChild(popup.lastChild);
	}

	var item = document.createElement("menuitem");
	item.setAttribute("id", "template-site-items-" + id);
	item.setAttribute("value", id);
	item.setAttribute("src", "chrome://" + id +"/skin/" + icon);
	item.setAttribute("label", sitename);
	
	if (!popup.hasChildNodes()) {
		list.selectedItem = item;
	}
	
	popup.appendChild(item);			

}

/******** ADD AREA ********/

function addUserWikiHeader(label,installurl,installtype) {
	//	only adding sites to this list so there is always just one parent
	if (document.getElementById('templates-tree-siteadmin').disabled) {
		document.getElementById('templates-tree-siteadmin').disabled = false;
	}
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');
	var cell = document.createElement('treecell');
	var child = document.createElement('treechildren');
	//	treecell
	cell.setAttribute("id", "treecell-id-" + installurl);
	cell.setAttribute("area", "site");
	cell.setAttribute("label", label);
	cell.setAttribute("installurl", installurl);
	cell.setAttribute("url", "");
	cell.setAttribute("lang", "");
	cell.setAttribute("installtype", installtype);
	row.appendChild(cell);
	//	treeitem
	item.setAttribute("id", 'templates-siteadmin-' + installurl);
	item.setAttribute("open", "false");
	if (installtype != "install") {
		item.setAttribute("container", "false");
	} else {
		item.setAttribute("container", "true");
	}
	item.appendChild(row);
	//	the child - stores the difference lang types
	child.setAttribute("id", 'templates-siteadmin-list-' + installurl);
	item.appendChild(child);
	//	add to the tree
	document.getElementById('templates-siteadmin').appendChild(item);
}

function addUserWikiItem(installurl,fullname,code,loc,type,installtype) {
	var item = document.createElement('treeitem');
	var row = document.createElement('treerow');
	var cell = document.createElement('treecell');
	//	row settings
	row.setAttribute("id", 'templates-siteadmin-list-row-' + installurl + '-' + code);
	//	cell settings
	//	check to see if the item is ON or OFF
	// default settings
	var select_image = IMAGE_OFF;
	var enabled = false;
	var count_site_active = wbPrefs.getIntPref(OPTION_USER_WIKI_SITE+".count");
	//	the for loop
	for (var i = 0; i < count_site_active; i++) {
		var active_code = wbPrefs.getCharPref(OPTION_USER_WIKI_SITE+"."+installurl+"."+i+".code");
		if (active_code == code) {
			select_image = IMAGE_ON;
			enabled = true;
		}
	}
	//	set the cell now..
	cell.setAttribute("src", select_image);
	cell.setAttribute("enabled", enabled);
	cell.setAttribute("area", "lang");
	cell.setAttribute("installurl", installurl);
	cell.setAttribute("url", loc);
	cell.setAttribute("lang", code);
	cell.setAttribute("type", type);
	cell.setAttribute("installtype", installtype);
	row.appendChild(cell);
	cell = document.createElement('treecell');
	cell.setAttribute("id", 'templates-cat-list-row-treecell-lang-' + installurl + '-' + code)
	cell.setAttribute("label", fullname + " (" + code + ")");
	row.appendChild(cell);
	//	item settings
	item.setAttribute("id", 'templates-siteadmin-list-item-' + installurl + '-' + code);
	item.appendChild(row);
	//	there is only just the
	document.getElementById('templates-siteadmin-list-' + installurl).appendChild(item);
}

/******* CLICK AREA ************/

function clickSiteAdminTemplate(e) {
	var tree = document.getElementById('templates-tree-siteadmin');
	var item = tree.view.getItemAtIndex(tree.currentIndex);
	var active = item.firstChild.firstChild;
	if (active.getAttribute('area') == "site") {
		document.getElementById('wiki-delete').disabled=!e;
	}  else {
		document.getElementById('wiki-delete').disabled=e;
	}
	if (active.getAttribute('area') == "lang") {
		var image = active.getAttribute("src");
		if (image == IMAGE_OFF) {
			active.setAttribute("src", IMAGE_ON);
			active.setAttribute("enabled", "true");
		} else {
			active.setAttribute("src", IMAGE_OFF);
			active.setAttribute("enabled", "false");
		}
		//	everytime we click, save.. just in-case
		store_lang('templates-siteadmin', "install");
	}
}

/******* ADD AREA DIALOG ************/

function addUserWiki(areainstall) {
    var ok = [false];
	var params = ["","",areainstall];
	window.openDialog("chrome://wikipedia/content/wikipedia_wiki_properties.xul", "&wikipedia.wiki.dialogtitle;","chrome,modal,centerscreen,resizable",ok,params);
	if (ok[0]) {
		var label = params[0];
		var installurl = params[1];
		var areainstall = params[2];
		var loc = params[3];
		var langcode = params[4];
		switch(areainstall) {
			case "install":
					addUserWikiHeader(decodeURIComponent(label), decodeURIComponent(installurl), "install");
				break;
				
			case "tmpl":

				break;
				
			case "basic":
					addUserWikiHeader(decodeURIComponent(label), decodeURIComponent(installurl), "basic");
					var cellid = document.getElementById('treecell-id-' + decodeURIComponent(installurl));
					cellid.setAttribute("url", decodeURIComponent(loc));
					cellid.setAttribute("lang", decodeURIComponent(langcode));
				break;
		}
	}
	store_site('templates-siteadmin', areainstall);
}

/*************** DELETE AREA **************/

function deleteUserWiki() {
	var tree = document.getElementById('templates-tree-siteadmin');
	var item = tree.view.getItemAtIndex(tree.currentIndex);
	var active = item.firstChild.firstChild;
	//	add a check here to confirm
	if (active.getAttribute('area') == "site") {
		document.getElementById('templates-siteadmin').removeChild(item);
		store_site('templates-siteadmin', "install");
		store_lang('templates-siteadmin', "install");
	}	
}

/*************** STORE AREA **************/

function save_usersite(cArray, value, installtype) {
	for (var i = 0; i < cArray.length; i++) {
		var usersite = cArray[i].firstChild.firstChild;
		var usersitechild = cArray[i].childNodes[1];
		
		if ((usersite.getAttribute('installtype') == "install") && (installtype == "install")) {
			if ((usersite.getAttribute('area') == "site") && (value == "site")) {
				wbPrefs.setCharPref(OPTION_USER_WIKI+"."+count+".label",encodeURIComponent(usersite.getAttribute("label")));
				wbPrefs.setCharPref(OPTION_USER_WIKI+"."+count+".installurl",encodeURIComponent(usersite.getAttribute("installurl")));
				count = count+1;
			}
			if ((usersite.getAttribute('area') == "lang") && (value == "lang")) {
				if (usersite.getAttribute('enabled') == "true") {
					wbPrefs.setCharPref(OPTION_USER_WIKI_SITE+"."+usersite.getAttribute('installurl')+"."+lcount+".code",encodeURIComponent(usersite.getAttribute("lang")));
					lcount = lcount+1;
				}
			}		
		}
		
		if ((usersite.getAttribute('installtype') == "basic") && (installtype == "basic")) {
			if ((usersite.getAttribute('area') == "site") && (value == "site")) {
				wbPrefs.setCharPref(OPTION_USER_WIKI_NOINSTALL+"."+bcount+".url",encodeURIComponent(usersite.getAttribute("url")));
				wbPrefs.setCharPref(OPTION_USER_WIKI_NOINSTALL+"."+bcount+".label",encodeURIComponent(usersite.getAttribute("label")));
				wbPrefs.setCharPref(OPTION_USER_WIKI_NOINSTALL+"."+bcount+".language",encodeURIComponent(usersite.getAttribute("lang")));
				wbPrefs.setCharPref(OPTION_USER_WIKI_NOINSTALL+"."+bcount+".installcode",encodeURIComponent(usersite.getAttribute("installurl")));
				bcount = bcount+1;
			}
		}
		
		if (usersitechild) {
			if (usersitechild.childNodes.length > 0) {
				save_usersite(usersitechild.childNodes, value, installtype); 
			}	
		}
	}
	
	if ((usersite.getAttribute('installtype') == "install") && (installtype == "install")) {
		if (value == "site") {
			wbPrefs.setIntPref(OPTION_USER_WIKI+".count",count);
		}
		if (value == "lang") {
			wbPrefs.setIntPref(OPTION_USER_WIKI_SITE+".count",lcount);
		}
	}
	if ((usersite.getAttribute('installtype') == "basic") && (installtype == "basic")) {
		if (value == "site") {
			wbPrefs.setIntPref(OPTION_USER_WIKI_NOINSTALL+".count",bcount);
		}
	}
}

function store_lang(treeName, installtype) {
	lcount = 0;
	var tree = document.getElementById(treeName).childNodes;
	save_usersite(tree, 'lang', installtype); 
}

function store_site(treeName, installtype) {
	count = 0;
	bcount = 0;
	var tree = document.getElementById(treeName).childNodes;
	save_usersite(tree, 'site', installtype); 
}